<template lang="pug">
.iframe_plugin
  transition(
    :key='visible',
    enter-active-class='animate__animated animate__fadeIn animate__fast',
    leave-active-class='animate__animated animate__fadeOut animate__fast'
  )
    .content.z-max(v-if='(visible && data.src) || demo')
      .column.justify-center.full-height
        .relative-position
          .slide.bordered(:style='{ height: height, width: width }')
            transition(
              mode='out-in',
              enter-active-class='animate__animated animate__fadeIn animate__fast',
              leave-active-class='animate__animated animate__fadeOut animate__fast'
            )
              iframe.fit.overflow-hidden(:src='data.src', style='border: none', ref='iframe')
</template>

<script>
export default {
  name: 'IframeOverlay',
  props: {
    firebase: {
      required: true,
    },
    context: {
      required: false,
    },
    demo: {
      default: false,
    },
  },
  computed: {
    ratio() {
      return this.iframe.ratio || 4.0 / 4.7;
    },
    height() {
      return `${550 / this.ratio}px`;
      //- height: 412px;
      //- width: 550px;
    },
    width() {
      return '600px';
    },
    visible() {
      if (typeof this.data.visible === 'undefined') {
        this.firebase.ref(`data/iframe/${this.context.meetingid}/visible`).set(false);
        return false;
      } else return this.data.visible;
    },
  },
  data: () => {
    return {
      iframe: {},
      data: {},
    };
  },

  watch: {
    firebase: {
      immediate: true,
      handler() {
        // console.log(this.firebase);
        // this.$rtdbBind(
        //   'iframe',
        //   this.firebase.ref(`config/${this.context.meetingid}/current/currentState/plugins/iframe`),
        // );

        if (this.demo !== true) this.$rtdbBind('data', this.firebase.ref(`data/iframe/${this.context.meetingid}`));
      },
    },
  },
};
</script>

<style src="animate.css/animate.css">
/* global styles */
</style>

<style lang="scss">
.iframe_plugin {
  .slide {
    // background: rgb(1, 77, 109);
    // background: white;
    // color: white;
    // border-radius: 5px;
    font-size: 26px;
    // filter: drop-shadow(0 0 10px #00000033);
    overflow: hidden;
    position: relative;
    margin-top: -50px;
  }

  .content {
    position: absolute;
    height: 720px;
    z-index: -3;
    left: 10px;
    // transform: perspective(1500px) rotateY(10deg);
  }
}
</style>
